<template>
  <div :class="['game-lobby-module-3', { 'px-2': isMobile }]">
    <div class="flex justify-between items-center">
      <div class="flex flex-nowrap items-center justify-start gap-2">
        <SvgIcon
          class="w-7 h-7 fill-primary"
          :class="{
            '!w-5 !h-5': isMobile,
          }"
          svg-name="icon-special-selection"
        />
        <span
          class="font-bold text-2xl text-[var(--text2)]"
          :class="{
            'text-base': isMobile,
          }"
          >{{ getDisplayName(gameSelected) }}
        </span>
      </div>
      <button
        class="bg-primary h-full text-base font-medium pl-4 pr-2 py-2 rounded-lg text-[var(--textBtn)] flex justify-center items-center gap-1"
        :class="{
          'pr-3 py-[7px]': isMobile,
        }"
        @click="onClickViewMore(gameSelected)"
      >
        <span
          class="capitalize"
          :class="{
            'text-xs': isMobile,
          }"
        >
          {{ $t("View More") }}
        </span>
        <SvgIcon
          class="w-6 h-6 z-10 !fill-[var(--textBtn)]"
          :class="{
            '!w-5 !h-5': isMobile,
          }"
          svg-name="play-button"
        />
      </button>
    </div>
    <div
      class="grid grid-cols-5 gap-5 mt-2 md:mt-4"
      :class="{
        '!grid-cols-3 !gap-2': isMobile,
      }"
    >
      <div
        v-for="(item, index) in getLobbyGamesByGameSelected"
        :key="`special_game_${index}`"
      >
        <div
          class="aspect-square relative flex items-center justify-center rounded-lg md:rounded-2xl overflow-hidden game-lobby-display-card"
        >
          <img
            v-lazy="item.GameIconUrl"
            class="object-cover w-full h-full transition-all duration-500 game-backgorund-image"
          />
          <div class="backdrop absolute top-0 left-0 w-full h-full" />
          <div
            v-if="item.IsNewGame && !isMobile"
            class="w-14 h-[26px] new-tag absolute top-0 left-0 text-center rounded-br-2xl flex justify-center items-center"
          >
            <span class="text-base text-white font-bold uppercase">{{ $t("new") }}</span>
          </div>
          <div
            v-if="item.IsHotGame && !item.IsNewGame && !isMobile"
            class="w-14 h-[26px] hot-tag absolute top-0 left-0 text-center rounded-br-2xl flex justify-center items-center"
          >
            <span class="text-base text-white font-bold uppercase">{{ $t("hot") }}</span>
          </div>
          <SharedGameTags
            v-if="isMobile"
            class="absolute top-[6px] left-[6px]"
            :is-hot="item.IsHotGame"
            :is-new="item.IsNewGame"
            width="32px"
          />
          <div
            class="absolute w-full h-full flex justify-center items-center cursor-pointer transition-all duration-500 play-button"
            @click="
              authenticated
                ? handleGameEntryOpenWindow(item, 850, 850)
                : toggleLoginRegisterDialog()
            "
          >
            <div
              class="relative w-16 h-16 rounded-full flex items-center justify-center"
            >
              <div
                class="w-16 h-16 rounded-full absolute bg-primary opacity-20"
              />
              <SvgIcon
                class="w-12 h-12 absolute z-10 fill-primary"
                svg-name="play-button"
              />
            </div>
          </div>
        </div>
        <div class="flex gap-2 mt-2 relative">
          <div class="flex-grow flex justify-left items-center pl-2">
            <span
              class="text-xs font-bold text-[var(--text2)]"
              :class="{
                '!text-[10px] max-w-[65px] truncate': isMobile,
              }"
            >
              {{ item.GameName }}
            </span>
          </div>
          <div
            class="relative w-8 aspect-square flex justify-center items-center cursor-pointer"
          >
            <IconFavoriteHeart
              :-for-mobile="true"
              :toggle-dialog="isMobile"
              :game-data="item"
              :check-is-favourite="checkIsFavourite"
              :redirect-to-login="redirectToLogin"
              :set-and-unset-game-to-favourite="setAndUnsetGameToFavourite"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script  lang="ts" setup>
import { useGameModule } from "@/composables/lobby/useGameModule";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import HotGame from "~/assets/icons/hot-games.svg?component";
import NewGame from "~/assets/icons/new-games.svg?component";
import { isString } from "lodash";

const props = defineProps<{
  gameSelected: string;
}>();
const {
  lobbyGames,
  getSpecialSelectionGameListInitial,
  authenticated,
  isMobile,
  selectedGameType,
  onClickViewMore,
  checkStatus,
  getHotGameListInitial,
  getNewGameListInitial,
  getGameListByGameTypeInitial,
  getDisplayName,
} = useGameModule();
const { toggleLoginRegisterDialog } = commonHelper;
const { setAndUnsetGameToFavourite, checkIsFavourite, redirectToLogin } =
  useAddToFavorite("-heart");
onMounted(() => {
  if (!isString(props.gameSelected) || ['Special Selection', ''].includes(props.gameSelected)) {
    getSpecialSelectionGameListInitial();
  } else if (props.gameSelected === 'Hot Games') {
    getHotGameListInitial();
  } else if (props.gameSelected === 'New Games') {
    getNewGameListInitial();
  } else {
    getGameListByGameTypeInitial();
  }
})
const getLobbyGamesByGameSelected = computed(() => {
  if (!isString(props.gameSelected) || ['Special Selection', ''].includes(props.gameSelected)) {
    return lobbyGames.value.SpecialSelectionForDisplay;
  } else if (props.gameSelected === 'Hot Games') {
    return lobbyGames.value.HotGameForDisplay;
  } else if (props.gameSelected === 'New Games') {
    return lobbyGames.value.NewGamesForDisplay;
  } else {
    selectedGameType.value = props.gameSelected.replace(/\s/g, "");
    return lobbyGames.value.GameByType;
  }
})
</script>

<style lang="scss" scoped>
.game-lobby-module-3 {
  .game-lobby-display-card {
    .backdrop {
      background: rgba(0, 0, 0, 0);
      transition: background-color 300ms;
    }
    .new-tag {
      background: rgba(42, 113, 220, 1);
    }
    .hot-tag {
      background: rgba(255, 38, 77, 1);
    }
    .game-backgorund-image {
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
    }
    .play-button {
      opacity: 0;
      pointer-events: none;
    }
  }
  .game-lobby-display-card:hover {
    .backdrop {
      background: rgba(0, 0, 0, 0.8);
    }
    .play-button {
      opacity: 1;
      pointer-events: unset;
    }
    .game-backgorund-image {
      width: calc(100% + 59px);
      height: calc(100% + 35px);
    }
  }
  .favourite-animation,
  .favourite-no-animation {
    width: 24px;
    height: 24px;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }
  .fill-tertiary {
    fill: var(--tertiary);
  }
  .fill-primary {
    fill: var(--primary);
  }
}
</style>
